unit Dibsprit;

interface

uses
  SysUtils, WinTypes, WinProcs, Classes, Graphics, Controls, WinGPnt, Sprite, DIB;

type

  TDIBSprite = class( TSprite )
  private
     FDIB: TDIB;
     nWidth, nHeight: word;
     nWidthDiv2, nHeightDiv2: word;
  protected
     procedure Render( winGPnt: TWinGPaintBox ); override;
  public
     constructor CreateFromDIB( dib: TDIB );
  end;

implementation

constructor TDIBSprite.CreateFromDIB( dib: TDIB );
begin
  inherited Create;
  FDIB := dib;
  nWidth := FDIB.Width;
  nHeight := FDIB.Height;
  nWidthDiv2 := FDIB.Width div 2;
  nHeightDiv2 := FDIB.Height div 2;
end;

procedure TDIBSprite.Render( winGPnt: TWinGPaintBox );
begin
  winGPnt.RenderDIB( FDIB, Point( ptPosition.X - nWidthDiv2, ptPosition.Y - nHeightDiv2 ) );
end;

end.
